$heightSelect: 2rem;

@mixin mat-custom-select-theme($theme) {

  $accent: map-get($theme, accent);
  $primary: map-get($theme, primary);
  $warn: map-get($theme, warn);

  .mat-form-field-appearance-outline .mat-form-field-infix {
    width: auto;
    max-width: 100%;
  }

  .mat-form-field-appearance-outline .mat-select {
    height: $heightSelect;
    line-height: $heightSelect;
    font-size: 0.8125rem;

    &-value-text, &-placeholder {
      font-weight: 600;
      color: mat-color($accent, 900);
    }

    &-disabled .mat-select-value span {
      color: mat-color($accent, 500);
    }

    &-arrow-wrapper {
      transform: none;
      line-height: 80%;
    }

    &-arrow {
      border-style: solid;
      border-color: mat-color($accent, 500);
      border-width: 0 0.125rem 0.125rem 0;
      display: inline-block;
      padding: 0.1875rem;
      transform: rotate(45deg) !important;
      vertical-align: top;
    }

    &-value {
      max-width: 100%;
      width: auto;
      padding-right: 0.25rem;
      min-width: 80px;
    }
  }
}

@mixin mat-unscoped-select-theme($theme) {

  $accent: map-get($theme, accent);
  $primary: map-get($theme, primary);

  .mat-select-panel {
    margin-top: $heightSelect + 0.5rem;
    margin-left: 0.5rem;
    max-width: 62.5rem !important;
    min-width: calc(100% + 4rem) !important;
    width: calc(100% - 2rem);
    overflow: hidden;
    text-overflow: ellipsis;
    white-space: nowrap;

    .mat-option {
      padding: 0 1rem;
      border-bottom: none;

      .mat-option-text {
        display: flex;
        align-items: center;
        justify-content: space-between;
        color: mat-color($accent, 700);
        font-size: 0.8125rem;
        font-weight: 600;

        icon-svg,
        mat-icon {
          display: none;
        }
      }

      &.mat-selected {
        background: mat-color($accent, 100);

        .mat-option-text {
          color: mat-color($accent, 900);

          icon-svg,
          mat-icon {
            display: initial;
            color: mat-color($primary, 500);
          }
        }
      }

      &.mat-selected.mat-active:not(.mat-option-multiple) {
        background-color: mat-color($primary, 100);
        font-weight: 500;
      }

      .mat-option-pseudo-checkbox {
        transition: border-color 0.1s ease;
        border-color: mat-color($accent, 500);
        border-radius: 0.1875rem !important;

        &.mat-pseudo-checkbox-checked {
          background: mat-color($primary, 700);
          border-color: mat-color($primary, 700);;
        }
      }

      &:hover {
        .mat-option-pseudo-checkbox {
          border-color: mat-color($accent, 700);

          &.mat-pseudo-checkbox-checked {
            border-color: mat-color($primary, 700);;
          }

        }

        &:last-child {
          border-bottom: none;
        }

        &:hover:not(.mat-option-disabled),
        &:focus:not(.mat-option-disabled) {
          background: mat-color($accent, 100);
          color: mat-color($accent, 900);
        }

        &.mat-selected:not(.mat-option-multiple) {
          background: mat-color($primary, 100);
          color: mat-color($accent, 900);
        }
      }
    }
  }
}
